commit 97c5b77774595c4dcef07223cd2684fea5201d5e
Author: Matt Turner <mattst88@gmail.com>
Date:   Wed Dec 15 13:34:48 2021 -0500

    xserver 1.20.14
    
    Signed-off-by: Matt Turner <mattst88@gmail.com>

commit 35b4681c79480d980bd8dcba390146aad7817c47
Author: Povilas Kanapickas <povilas@radix.lt>
Date:   Tue Dec 14 15:00:03 2021 +0200

    render: Fix out of bounds access in SProcRenderCompositeGlyphs()
    
    ZDI-CAN-14192, CVE-2021-4008
    
    This vulnerability was discovered and the fix was suggested by:
    Jan-Niklas Sohn working with Trend Micro Zero Day Initiative
    
    Signed-off-by: Povilas Kanapickas <povilas@radix.lt>
    (cherry picked from commit ebce7e2d80e7c80e1dda60f2f0bc886f1106ba60)

commit 67425fcab50ef24a5617e109897f38876dd81277
Author: Povilas Kanapickas <povilas@radix.lt>
Date:   Tue Dec 14 15:00:02 2021 +0200

    Xext: Fix out of bounds access in SProcScreenSaverSuspend()
    
    ZDI-CAN-14951, CVE-2021-4010
    
    This vulnerability was discovered and the fix was suggested by:
    Jan-Niklas Sohn working with Trend Micro Zero Day Initiative
    
    Signed-off-by: Povilas Kanapickas <povilas@radix.lt>
    (cherry picked from commit 6c4c53010772e3cb4cb8acd54950c8eec9c00d21)

commit 6bb8aeb30a2686facc48733016caade97ece10ad
Author: Povilas Kanapickas <povilas@radix.lt>
Date:   Tue Dec 14 15:00:01 2021 +0200

    xfixes: Fix out of bounds access in *ProcXFixesCreatePointerBarrier()
    
    ZDI-CAN-14950, CVE-2021-4009
    
    This vulnerability was discovered and the fix was suggested by:
    Jan-Niklas Sohn working with Trend Micro Zero Day Initiative
    
    Signed-off-by: Povilas Kanapickas <povilas@radix.lt>
    (cherry picked from commit b5196750099ae6ae582e1f46bd0a6dad29550e02)

commit acc50e6097d51fec0c6c34d84c35018a50c52d5a
Author: Povilas Kanapickas <povilas@radix.lt>
Date:   Tue Dec 14 15:00:00 2021 +0200

    record: Fix out of bounds access in SwapCreateRegister()
    
    ZDI-CAN-14952, CVE-2021-4011
    
    This vulnerability was discovered and the fix was suggested by:
    Jan-Niklas Sohn working with Trend Micro Zero Day Initiative
    
    Signed-off-by: Povilas Kanapickas <povilas@radix.lt>
    (cherry picked from commit e56f61c79fc3cee26d83cda0f84ae56d5979f768)

commit 5ff3310b69463cf85ea5eec76634cd7377a935e5
Author: Mario Kleiner <mario.kleiner.de@gmail.com>
Date:   Sat Aug 28 02:27:20 2021 +0200

    modesetting: Allow Present flips with mismatched stride on atomic drivers.
    
    When using DRI3+Present with PRIME render offload, sometimes there is
    a mismatch between the stride of the to-be-presented Pixmap and the
    frontbuffer. The current code would reject a pageflip present in this
    case if atomic modesetting is not enabled, ie. always, as atomic
    modesetting is disabled by default due to brokeness in the current
    modesetting-ddx.
    
    Fullscreen presents without page flipping however trigger the copy
    path as fallback, which causes not only unreliable presentation timing
    and degraded performance, but also massive tearing artifacts due to
    rendering to the framebuffer without any hardware sync to vblank.
    Tearing is extra awful on modesetting-ddx because glamor afaics seems
    to use drawing of a textured triangle strip for the copy implementation,
    not a dedicated blitter engine. The rasterization pattern creates extra
    awful tearing artifacts.
    
    We can do better: According to a tip from Michel Daenzer (thanks!),
    at least atomic modesetting capable kms drivers should be able to
    reliably change scanout stride during a pageflip, even if atomic
    modesetting is not actually enabled for the modesetting client.
    
    This commit adds detection logic to find out if the underlying kms
    driver is atomic_modeset_capable, and if so, it no longer rejects
    page flip presents on mismatched stride between new Pixmap and
    frontbuffer.
    
    We (ab)use a call to drmSetClientCap(ms->fd, DRM_CLIENT_CAP_ATOMIC, 0);
    for this purpose. The call itself has no practical effect, as it
    requests disabling atomic mode, although atomic mode is disabled by
    default. However, the return value of drmSetClientCap() tells us if the
    underlying kms driver is atomic modesetting capable: An atomic driver
    will return 0 for success. A legacy non-atomic driver will return a
    non-zero error code, either -EINVAL for early atomic Linux versions
    4.0 - 4.19 (or for non-atomic Linux 3.x and earlier), or -EOPNOTSUPP
    for Linux 4.20 and later.
    
    Testing on a MacBookPro 2017 with Intel Kabylake display server gpu +
    AMD Polaris11 as prime renderoffload gpu, X-Server master + Mesa 21.0.3
    show improvement from unbearable tearing to perfect, despite a stride
    mismatch between display gpu and Pixmap of 11776 Bytes vs. 11520
    Bytes. That this is correct behaviour was also confirmed by comparing the
    behaviour and .check_flip implementation of the patched modesetting-ddx
    against the current intel-ddx SNA Present implementation.
    
    Please consider merging this patch before the server-1.21 branch point.
    This patch could also be cherry-picked into the server 1.20 branch to
    fix the same limitation.
    
    Signed-off-by: Mario Kleiner <mario.kleiner.de@gmail.com>
    (cherry picked from commit 8f8ebf870b55c9875b7cfd8ef69c1df02d589b4a)

commit 574fe59ef0669d4754884a115016d393d187848a
Author: Mario Kleiner <mario.kleiner.de@gmail.com>
Date:   Mon Oct 18 08:14:04 2021 +0200

    Fix RandR leasing for more than 1 simultaneously active lease.
    
    Due to a switched order of parameters in the xorg_list_add()
    call inside ProcRRCreateLease(), adding a new lease for RandR
    output leasing does not actually add the new RRLeasePtr lease
    record to the list of existing leases for a X-Screen, but instead
    replaces the existing list with a new list that has the new lease
    as the only element, and probably leaks a bit of memory.
    
    Therefore the server "forgets" all active leases for a screen,
    except for the last added lease. If multiple leases are created
    in a session, then destruction of all leases but the last one
    will fail in many cases, e.g., during server shutdown in
    RRCloseScreen(), or resource destruction, e.g., in
    RRCrtcDestroyResource().
    
    Most importantly, it fails if a client simply close(fd)'es the
    DRM master descriptor to release a lease, quits, gets killed or
    crashes. In this case the kernel will destroy the lease and shut
    down the display output, then send a lease event via udev to the
    ddx, which e.g., in the modesetting-ddx will trigger a call to
    drmmode_validate_leases().
    
    That function is supposed to detect the released lease and tell
    the server to terminate the lease on the server side as well,
    via xf86CrtcLeaseTerminated(), but this doesn't happen for all
    the leases the server has forgotten. The end result is a dead
    video output, as the server won't reinitialize the crtc's
    corresponding to the terminated but forgotten lease.
    
    This bug was observed when using the amdvlk AMD OSS Vulkan
    driver and trying to lease multiple VKDisplay's, and also
    under Mesa radv, as both Mesa Vulkan/WSI/Display and amdvlk
    terminate leases by simply close()ing the lease fd, not by
    sending explicit RandR protocol requests to free leases.
    
    Leasing worked, but ending a session with multiple active
    leases ended in a lot of unpleasant darkness.
    
    Fixing the wrong argument order to xorg_list_add() fixes the
    problem. Tested on single-X-Screen and dual-X-Screen setups,
    with one, two or three active leases.
    
    Please merge this for the upcoming server 21.1 branch.
    Merging into server 1.20 would also make a lot of sense.
    
    Fixes: e4e3447603b5fd3a38a92c3f972396d1f81168ad
    Signed-off-by: Mario Kleiner <mario.kleiner.de@gmail.com>
    Reviewed-by: Keith Packard <keithp@keithp.com>
    (cherry picked from commit f467f85ca1f780d5c7cf3c20888e399708d761ac)

commit 86a72cb1927dd91132d231bb7920b651704601ef
Author: Matt Turner <mattst88@gmail.com>
Date:   Thu Jul 29 11:23:15 2021 -0700

    xserver 1.20.13
    
    Signed-off-by: Matt Turner <mattst88@gmail.com>

commit f85e4edba489316950fc3422f39e3c2ef8fb1ac5
Author: Łukasz Spintzyk <lukasz.spintzyk@synaptics.com>
Date:   Thu Jul 22 13:12:05 2021 +0200

    modesetting: unflip not possible when glamor is not set
    
    This is fixing crashes of xfce when running under qemu
    
    (cherry picked from commit 8836b9d243444031b6396d39d345f2f83b5fa6a9)

commit b03d7184b7906121a432b05473675937ab6c0f1e
Author: Łukasz Spintzyk <lukasz.spintzyk@synaptics.com>
Date:   Mon Jul 19 14:25:28 2021 +0200

    present: fallback get_crtc to return crtc belonging to screen with present extension
    
    Since crtc can belong to secondary output that may not have present
    extension enabled we should fallback to first enabled crtc or fake crtc.
    
    Fix for issue xorg/xserver#1195
    
    (cherry picked from commit d6c02ffd9c910637f6b3b7249507998e9e45f93c)

commit b88ad0b342c954109bfd4b1d32c04ff55545cb0f
Author: Matt Turner <mattst88@gmail.com>
Date:   Thu Jul 8 12:15:21 2021 -0700

    xserver 1.20.12
    
    Signed-off-by: Matt Turner <mattst88@gmail.com>

commit 8dea50223b9b9495aa2e2f4e6aef2a842c0e0a2f
Author: Matt Turner <mattst88@gmail.com>
Date:   Thu Jul 8 12:15:13 2021 -0700

    Build xz tarballs instead of bzip2
    
    Signed-off-by: Matt Turner <mattst88@gmail.com>

commit b7adbac7d14bca3b0790fd7d1a706be28d954af5
Author: orbea <orbea@riseup.net>
Date:   Wed Jun 23 05:50:21 2021 -0700

    hw/dmx/config: Link directly with libdmxconfig.a
    
    When building xserver with slibtool (https://dev.midipix.org/cross/slibtool)
    the build will fail.
    
      /usr/bin/ld: cannot find -ldmxconfig
    
    This is because xserver creates libdmxconfig.a internally and then links with
    the linker flag -ldmxconfig. However according to automake documentation the
    -lfoo linker flags should only be used for external dependencies and all
    internal libraries should be linked with the libtool archive file (.la) or
    the static archive (.a) when the former is not available.
    
    GNU libtool is far more permissive and happens to silently obscure this issue
    while slibtool fails because it instead sees '-L./.libs -ldmxconfig'.
    
    Signed-off-by: Matt Turner <mattst88@gmail.com>
    (cherry picked from commit 2531ee02450e3be3549daa09407557c3addeba02)

commit e49738f0c9d4370c7a7e6e86c2c74151aa2e33fa
Author: Zoltán Böszörményi <zboszor@pr.hu>
Date:   Mon Jun 21 12:12:41 2021 +0200

    xfree86: Fix NULL pointer dereference crash
    
    screenp->displays[count] (passed to configDisplay() in
    configScreen()) is NULL if there is no Virtual setting
    in the configuration.
    
    Fixes: f8a6be04d0c7e6a99824ff888ad6c010960c5c21 ("xfree86: Change
    displays array to pointers array to fix invalid pointer issues
    after table reallocation")
    
    Signed-off-by: Zoltán Böszörményi <zboszor@gmail.com>
    (cherry picked from commit ef89b6648e2a806237a6d2fa598e1b9c83f128b4)

commit 9a59631a490876eae57f813e3a274c46d35d5287
Author: Olivier Fourdan <ofourdan@redhat.com>
Date:   Fri Jun 18 14:52:55 2021 +0200

    glx: Fix use after free in MakeCurrent
    
    The fix from commit c468d34c7 - "glx: Set ContextTag for all contexts"
    is actually incomplete, it correctly sets the context tag for direct
    contexts as well, but would fail to mark the context's currentClient.
    
    As a result, when the context is destroyed, it would be freed
    immediately rather than being just scheduled for deletion, even though
    it is still current for some client. leading to a use-after-free.
    
    Make sure to also set the context's currentClient for direct contexts as
    well, not just indirect ones.
    
    Signed-off-by: Olivier Fourdan <ofourdan@redhat.com>
    Fixes: c468d34c7 - "glx: Set ContextTag for all contexts"
    Closes: https://gitlab.freedesktop.org/xorg/xserver/-/issues/1186
    Reviewed-by: Adam Jackson <ajax@redhat.com>
    (cherry picked from commit aad61e8e03311eb8bae4f7db59e65634733eadc2)

commit 1fc0ca6e680fbc50b7a4b60b8797d0fce69cf6fb
Author: Łukasz Spintzyk <lukasz.spintzyk@synaptics.com>
Date:   Wed Jun 23 15:26:23 2021 +0200

    xfree86: Fix out of array bound access to xf86Entities
    
    Signed-off-by: Łukasz Spintzyk <lukasz.spintzyk@synaptics.com>
    (cherry picked from commit d66b7ec12986efd4f32fcc84cdaacbd04ec98ccb)

commit a4210fe07a8bd5fd4851ffa202ecffca1cc8062c
Author: Łukasz Spintzyk <lukasz.spintzyk@synaptics.com>
Date:   Tue Jun 8 20:02:21 2021 +0200

    xfree86: Change displays array to pointers array to fix invalid pointer issues after table reallocation
    
    There are rare cases when xf86SetDepthBpp is resizing displays array in confScreen.
    As that array is shared between set of ScrnInfoRec's then realloc might invalidate chached DispPtr display values in
    otheres ScrnInfoRec objects.
    
    If we will change displays array as an array of pointers to DispRec then cached DispRec pointers in ScrnInfoRec
    won't be invalid after reallocation of displays array.
    
    Signed-off-by: Łukasz Spintzyk <lukasz.spintzyk@synaptics.com>
    (cherry picked from commit f8a6be04d0c7e6a99824ff888ad6c010960c5c21)

commit 22449f6300aad600cc49024640651a46a128e3ad
Author: Jose Maria Casanova Crespo <jmcasanova@igalia.com>
Date:   Tue Jun 8 14:52:17 2021 +0200

    glamor: Avoid using GL_QUADS on V3D
    
    Like in 0e3f1252dacdc3194 ("glamor: Avoid using GL_QUADS on VC4")
    this will avoid mesa to fallback doing conversion for QUADS primitives.
    
    Signed-off-by: Jose Maria Casanova Crespo <jmcasanova@igalia.com>
    Reviewed-by: Emma Anholt <emma@anholt.net>
    (cherry picked from commit 9adb13e296baead53112a268ddfd291195742c71)

commit d16f6403153596b62c555fb511881289f59f9e81
Author: Ville Syrjälä <ville.syrjala@linux.intel.com>
Date:   Tue Sep 3 16:44:56 2019 +0300

    modesetting: Fix possible_crtcs
    
    Populate outout possible_crtcs as the union of possible_crtcs from
    the encoders rather than the intersection. Otherwise we're easily left
    with possible_crtcs==0 when all the possible encoders have
    non-overlapping possible_crtcs.
    
    No idea what the magic 0x7f is about, but keep it around in case
    it matters.
    
    Signed-off-by: Ville Syrjälä <ville.syrjala@linux.intel.com>
    (cherry picked from commit 0e4bd71d02d09c320e76280ae8f14df169387507)

commit f1e76731a02e77c73521134933e424a17df40a1c
Author: Ville Syrjälä <ville.syrjala@linux.intel.com>
Date:   Tue Aug 20 17:46:09 2019 +0300

    modesetting: Update props for dynamically added outputs
    
    Dynamically added outputs should have their properties
    properly updated as well. Otherwise we're left with an output
    with many of its propeties not exposed.
    
    Signed-off-by: Ville Syrjälä <ville.syrjala@linux.intel.com>
    Reviewed-by: Michel Dänzer <michel@daenzer.net>
    Closes: https://gitlab.freedesktop.org/xorg/xserver/-/issues/1143
    (cherry picked from commit 0c5179c280a193a1dbbe29160906087f06eae6f2)

commit 7bf4777116b9b6d416914561015662f494bb4184
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Mon Mar 8 21:02:40 2021 -0800

    xquartz: Ensure the mouse pointer is shown when switching to a native macOS alert or window
    
    Fixes: https://github.com/XQuartz/XQuartz/issues/100
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
    (cherry picked from commit 4ae36f418ed683532b0b6991e4a1e7d56740b845)

commit 3ef6e7b766a9f20b208b50203ad6b45f65fbc29e
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Fri Mar 5 22:57:24 2021 -0800

    xquartz: Fix appFlags build failure with macOS 10.15+ SDKs
    
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
    (cherry picked from commit e59848548a462f1a0ac751bb8bb6afe56258cf4e)

commit 2a83c840c8f38281b7f93b5522e20a71f6723b08
Author: Olivier Fourdan <ofourdan@redhat.com>
Date:   Thu Jun 3 17:51:01 2021 +0200

    glx: Set ContextTag for all contexts
    
    Currently, xorgGlxMakeCurrent() would set the context tag only for
    indirect GLX contexts.
    
    However, several other places expect to find a context for the tag or
    they would raise a GLXBadContextTag error, such as WaitGL() or WaitX().
    
    Set the context tag for direct contexts as well, to avoid raising an
    error and possibly killing the client.
    
    Thanks to Erik Kurzinger <ekurzinger@nvidia.com> for spotting the issue.
    
    Signed-off-by: Olivier Fourdan <ofourdan@redhat.com>
    Reviewed-by: Adam Jackson <ajax@redhat.com>
    (cherry picked from commit c468d34c7208c9041f9c077b54a00ae9cccad6a3)

commit 394b6cc1cf614ba7b13db7976b0739035da86d28
Author: Erik Kurzinger <ekurzinger@nvidia.com>
Date:   Thu Dec 10 14:24:32 2020 -0800

    glx: don't create implicit GLXWindow if one already exists
    
    If a GLXMakeCurrent request specifies an X window as its drawable,
    __glXGetDrawable will implicitly create a GLXWindow for it. However,
    the client may have already explicitly created a GLXWindow for that X
    window. If that happens, two __glXDrawableRes resources will be added
    to the window.
    
    If the explicitly-created GLXWindow is later destroyed by the client,
    DrawableGone will call FreeResourceByType on the X window, but this
    will actually free the resource for the implicitly-created GLXWindow,
    since that one would be at the head of the list.
    
    Then if the X window is destroyed after that, the resource for the
    explicitly-created GLXWindow will be freed. But that GLXWindow was
    already destroyed above. This crashes the server when it tries to call
    the destroyed GLXWindow's destructor. It also means the
    implicitly-created GLXWindow would have been leaked since the
    FreeResourceByType call mentioned above skips calling the destructor.
    
    To fix this, if __glXGetDrawable is given an X window, it should check
    if there is already a GLXWindow associated with it, and only create an
    implicit one if there is not.
    
    Signed-off-by: Erik Kurzinger <ekurzinger@nvidia.com>
    Reviewed-by: Adam Jackson <ajax@redhat.com>
    (cherry picked from commit b7a85e44da91d1663d5b4eabac06327c92a80f91)

commit 0086535e7a331f81823a0f4e578bc3346ee1c312
Author: Łukasz Spintzyk <lukasz.spintzyk@synaptics.com>
Date:   Fri Sep 18 14:32:01 2020 +0200

    modesetting: Remove few common functions from ms namespace
    
    A lot of that code is the same as in xf86-amdgpu and xf86-nouveau drivers. By removing that functions from
    ms namespace we can move that code to common implementation.
    
    Signed-off-by: Łukasz Spintzyk <lukasz.spintzyk@synaptics.com>
    (cherry picked from commit 5be3b80b8d084ca5721be8791910d5827d1b6014)

commit 321964443be6b6daae0f7c1097a34106782ae338
Author: Łukasz Spintzyk <lukasz.spintzyk@synaptics.com>
Date:   Fri Sep 18 14:31:53 2020 +0200

    modesetting: remove unnecessary ms_covering_xf86_crtc dup of ms_covering_randr_crtc
    
    Signed-off-by: Łukasz Spintzyk <lukasz.spintzyk@synaptics.com>
    (cherry picked from commit c282be503e267afdd050df837d4cf61e0e7287b7)

commit 52eb801d048f63952ca48487d86ba089dfcbe131
Author: Łukasz Spintzyk <lukasz.spintzyk@synaptics.com>
Date:   Fri Sep 18 14:31:47 2020 +0200

    modesetting: Find crtc on slave outputs as fallback instead of returning primary crtc
    
    Signed-off-by: Łukasz Spintzyk <lukasz.spintzyk@synaptics.com>
    (cherry picked from commit b923364c5ec8251e81b4aa5fd451d9d7bb038009)

commit c7a2da7b994cdf829d805944c80f9fefd9246109
Author: Łukasz Spintzyk <lukasz.spintzyk@synaptics.com>
Date:   Fri Sep 18 14:31:34 2020 +0200

    present: fix msc offset calculation in screen mode
    
    Instead of getting the current msc value from the window crtc,
    which not exist take the last saved msc value saved in
    the window_priv struct
    
    Signed-off-by: Łukasz Spintzyk <lukasz.spintzyk@synaptics.com>
    (cherry picked from commit d2dce22b6775c772282ac2c0e224ef9685ab34fa)

commit 31544e68e605f0595e700bf4ce468b16e7b195ac
Author: Łukasz Spintzyk <lukasz.spintzyk@synaptics.com>
Date:   Fri Sep 18 14:31:25 2020 +0200

    present: Use crtc's screen present operation for syncing
    
    Signed-off-by: Łukasz Spintzyk <lukasz.spintzyk@synaptics.com>
    (cherry picked from commit 908deb0895f9fe345d70be933d251ea10511d30a)

commit 464cbee1c625d60ac9e18b7f4e3d53bc83b0d585
Author: Łukasz Spintzyk <lukasz.spintzyk@synaptics.com>
Date:   Fri Sep 18 14:29:25 2020 +0200

    modesetting: Initialize present extension despite glamor is disabled
    
    Signed-off-by: Łukasz Spintzyk <lukasz.spintzyk@synaptics.com>
    (cherry picked from commit d03c0de77ba36bb5221d00ac84dcdd6aae0df453)

commit 4e11bd390a28144fac03dc21a6caf0800596e2fa
Author: Łukasz Spintzyk <lukasz.spintzyk@synaptics.com>
Date:   Tue Jun 8 18:53:07 2021 +0200

    modesetting: Disable reverse prime offload mode for displays running on evdi,udl
    
    This mode for displays running on evdi/udl as side effect of failed glamor_egl_init
    reverse_prime_offload_mode was initialized to FALSE
    
    After Mesa upgrade to 21.0.0 GL_RENDERER is not llvmpipe that results in successful glamor_egl_init
    and reverse_prime_offload_mode enabled.
    
    This commit is explicitly disabling reverse_prime_offload_mode for evdi and udl drivers
    
    Signed-off-by: Łukasz Spintzyk <lukasz.spintzyk@synaptics.com>
    (cherry picked from commit 7e7c147105ac704a7b33bdee0f85dc9ccdd8f747)

commit 6272529339f975777f22bb0e6162ac43480ae257
Author: Olivier Fourdan <ofourdan@redhat.com>
Date:   Mon Feb 15 11:33:56 2021 +0100

    dix: Guard against non-existing PtrFeedbackPtr
    
    Trying to change the pointer control settings on a device without
    PtrFeedbackPtr would be a bug and a crash in the Xserver.
    
    Guard against that case by returning early with a BadImplementation
    error, that might kill the X11 client but the Xserver would survive.
    
    Signed-off-by: Olivier Fourdan <ofourdan@redhat.com>
    Reviewed-by: Peter Hutterer <peter.hutterer@who-t.net>
    Related: https://gitlab.freedesktop.org/xorg/xserver/-/issues/1137
    (cherry picked from commit dee2bb033e78e2f4aae7f5708c3d4fc74a9957de)

commit d41b43345cde2330648ad1890fb95bdbd5362f7f
Author: Olivier Fourdan <ofourdan@redhat.com>
Date:   Mon Feb 15 11:23:59 2021 +0100

    xwayland: Add PtrFeedback to the touch device
    
    Trying to change the acceleration/threshold on Xwayland cannot work, and
    the corresponding handler xwl_pointer_control() is a no-op.
    
    Yet, an X11 client trying to change those on the touch device may
    possibly cause a crash because the touch device in Xwayland doesn't set
    that.
    
    Initialize the touch device's PtrFeedback to make sure that just cannot
    happen.
    
    Signed-off-by: Olivier Fourdan <ofourdan@redhat.com>
    Reviewed-by: Peter Hutterer <peter.hutterer@who-t.net>
    Closes: https://gitlab.freedesktop.org/xorg/xserver/-/issues/1137
    (cherry picked from commit ab76272a7d2bff997985893c89147412a7360310)

commit 23a53f0d5460eb45f05b0b370dfcec712652598c
Author: Vasily Khoruzhick <anarsoul@gmail.com>
Date:   Fri Mar 20 20:36:25 2020 -0700

    glx: fixup symbol name for get_extensions function
    
    glxProbeDriver() concatenates __DRI_DRIVER_GET_EXTENSIONS with driver name
    to get symbol name for get_extension function. Unfortunately that doesn't
    work for drivers that have hyphen in their name, e.g. sun4i-drm --
    get_extensions() for these uses underscore instead.
    
    As result dlsym() doesn't find get_extension() function and AIGLX
    initialization fails resulting in following message in Xorg.0.log:
    
    (EE) AIGLX error: sun4i-drm does not export required DRI extension
    
    Replace all non-alpha-numeric characters with underscore to fix the issue.
    
    Signed-off-by: Vasily Khoruzhick <anarsoul@gmail.com>
    (cherry picked from commit b56e501092169a9c0a60663d832ee71898a8bc4b)

commit 6b767cdf6574081164aa6c6a7b617cda579b84c6
Author: Matt Turner <mattst88@gmail.com>
Date:   Tue Apr 13 10:01:34 2021 -0400

    xserver 1.20.11
    
    Signed-off-by: Matt Turner <mattst88@gmail.com>

commit a1a1aa2c14636284669b28a956d756d5705dcf15
Author: Matthieu Herrb <matthieu@herrb.eu>
Date:   Sun Mar 21 18:38:57 2021 +0100

    Fix XChangeFeedbackControl() request underflow
    
    CVE-2021-3472 / ZDI-CAN-1259
    
    This vulnerability was discovered by:
    Jan-Niklas Sohn working with Trend Micro Zero Day Initiative
    
    Signed-off-by: Matthieu Herrb <matthieu@herrb.eu>

commit 8890c44a75304097667ac7d42e83e2d78b105cb5
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Sun Feb 21 21:49:58 2021 -0800

    xquartz: Remove a check for NSAppKitVersionNumber >= NSAppKitVersionNumber10_7
    
    This check is always true on our supported systems.
    
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
    (cherry picked from commit 5ae47a9d579e8cb0fbe938455faea53ed75d7098)

commit 3c3680c366f78168e828e4a35d41a048c6e2bb54
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Sun Feb 21 21:49:14 2021 -0800

    xquartz: Don't include strndup.c any more since we no longer support 10.8 and older
    
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
    (cherry picked from commit b960675257d301605def6008bddcccb0980a3c4c)

commit e1fdc856aedfcb4788011415930a0c6861df5123
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Sun Feb 21 20:58:42 2021 -0800

    xquartz: Add a launch trampoline to better integrate with modern versions of macOS
    
    Fixes: https://github.com/XQuartz/XQuartz/issues/6
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
    (cherry picked from commit 694724e42c4a3eadb32891220084b03504f9586b)

commit 8f8e9c53e71ca58e8c23482d8f37687840371cda
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Fri Feb 19 23:16:56 2021 -0800

    xquartz: Don't process AppKit events if we haven't finished initializing
    
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
    (cherry picked from commit 25035229b73742f9e6a96ac3e535b30b5c6196a8)

commit aa6f84021aaae145f54ebf98787e363e1c2022c6
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Sat Feb 20 17:24:14 2021 -0800

    xquartz: Allocate each fbconfig separately
    
    A change during the 1.20 development cycle resulted in fbconfigs being walked
    and deallocated individually during __glXScreenDestroy.  This change
    now avoids a use-after-free caused by that change.
    
    ==50859==ERROR: AddressSanitizer: heap-use-after-free on address 0x00010d3819c8 at pc 0x0001009d4230 bp 0x00016feca7a0 sp 0x00016feca798
    READ of size 8 at 0x00010d3819c8 thread T5
        #0 0x1009d422c in __glXScreenDestroy glxscreens.c:448
        #1 0x10091cc98 in __glXAquaScreenDestroy indirect.c:510
        #2 0x1009d2734 in glxCloseScreen glxscreens.c:169
        #3 0x100740a24 in dix_main main.c:325
        #4 0x10023ed50 in server_thread quartzStartup.c:65
        #5 0x199ae7fd0 in _pthread_start+0x13c (libsystem_pthread.dylib:arm64e+0x6fd0)
        #6 0x199ae2d38 in thread_start+0x4 (libsystem_pthread.dylib:arm64e+0x1d38)
    
    0x00010d3819c8 is located 200 bytes inside of 12800-byte region [0x00010d381900,0x00010d384b00)
    freed by thread T5 here:
        #0 0x101477ba8 in wrap_free+0x98 (libclang_rt.asan_osx_dynamic.dylib:arm64e+0x3fba8)
        #1 0x1009d4240 in __glXScreenDestroy glxscreens.c:449
        #2 0x10091cc98 in __glXAquaScreenDestroy indirect.c:510
        #3 0x1009d2734 in glxCloseScreen glxscreens.c:169
        #4 0x100740a24 in dix_main main.c:325
        #5 0x10023ed50 in server_thread quartzStartup.c:65
        #6 0x199ae7fd0 in _pthread_start+0x13c (libsystem_pthread.dylib:arm64e+0x6fd0)
        #7 0x199ae2d38 in thread_start+0x4 (libsystem_pthread.dylib:arm64e+0x1d38)
    
    previously allocated by thread T5 here:
        #0 0x101477e38 in wrap_calloc+0x9c (libclang_rt.asan_osx_dynamic.dylib:arm64e+0x3fe38)
        #1 0x100925a40 in __glXAquaCreateVisualConfigs visualConfigs.c:116
        #2 0x10091cb24 in __glXAquaScreenProbe+0x224 (X11.bin:arm64+0x100730b24)
        #3 0x1009cd840 in xorgGlxServerInit glxext.c:528
        #4 0x10074539c in _CallCallbacks dixutils.c:743
        #5 0x100932a70 in CallCallbacks callback.h:83
        #6 0x100932478 in GlxExtensionInit vndext.c:244
        #7 0x10020a364 in InitExtensions miinitext.c:267
        #8 0x10073fe7c in dix_main main.c:197
        #9 0x10023ed50 in server_thread quartzStartup.c:65
        #10 0x199ae7fd0 in _pthread_start+0x13c (libsystem_pthread.dylib:arm64e+0x6fd0)
        #11 0x199ae2d38 in thread_start+0x4 (libsystem_pthread.dylib:arm64e+0x1d38)
    
    Regressed-in: 4b0a3cbab131eb453e2b3fc0337121969258a7be
    CC: Giuseppe Bilotta <giuseppe.bilotta@gmail.com>
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
    (cherry picked from commit 487286d47260782d331229af10df17711cbca1ea)

commit 7aa51bb5728f001bdffdca7f669db1678d903160
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Sat Feb 20 15:17:18 2021 -0800

    xquartz: Fix a compiler warning about const incompatible pointer assignment
    
    driWrap.c:541:30: error: assigning to 'GCOps *' (aka 'struct _GCOps *') from 'const GCOps *' (aka 'const struct _GCOps *') discards
          qualifiers [-Werror,-Wincompatible-pointer-types-discards-qualifiers]
            pGCPriv->originalOps = pGC->ops;
                                 ^ ~~~~~~~~
    
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
    (cherry picked from commit 6a83fb51b7a8b2e167e7d6380229b69e5452f91f)

commit d751c46bd7ce1f350df04cfc9ec9f3ba73058ccd
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Thu Feb 18 23:16:15 2021 -0800

    xquartz: Fix build with sparkle enabled
    
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
    (cherry picked from commit a3ddcdd56c246e2226c7cdf372c2a1294eb6d888)

commit 03c2e12a82e772461e069addbafdecdfff029ca5
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Thu Feb 18 12:43:53 2021 -0800

    xquartz: Silence a compiler warning about missing internal methods on NSApplication
    
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
    (cherry picked from commit 279bcbd9cf9e557a6789d6e4cede8e8799c3788e)

commit fcbd57367ef2daa125d7acbbf00953477f9dc5cc
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Thu Feb 18 22:19:21 2021 -0800

    xquartz: Rewrite Window menu handling to not depend on X11App.windowsMenu.numberOfItems being correct in -awakeFromNib
    
    Fixes: https://github.com/XQuartz/XQuartz/issues/56
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
    (cherry picked from commit fe89c70e472a9da0541b798eea60c5362b49a99d)

commit b27c6602b39e02aa7ef25ea03b59ef499fc3dc1e
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Thu Feb 18 15:41:29 2021 -0800

    xquartz: Convert X11Controller ivars into @properties
    
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
    (cherry picked from commit 41aed8f69634ec61ea0e40fff1cfdaf868be843e)

commit 625c7e4deced7e57a724b05750a92586a2785ff0
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Thu Feb 18 14:39:46 2021 -0800

    xquartz: Convert X11Application ivars into @properties
    
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
    (cherry picked from commit c2750e1fab774c8e6675ecf284124ff55b5be9cf)

commit 3017fec60581c1ab32ad3d6768baf04179fda5e2
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Thu Feb 18 14:47:50 2021 -0800

    xquartz: Fold quartzCommon.h into quartz.h
    
    Everything declared in it comes from quartz.c, so match reality.
    
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
    (cherry picked from commit f51b97b0de2e562e341f2d72c5f00a74c71a159f)

commit bdaff44f98587fd0112f3d86a461ee3ce190277c
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Thu Feb 18 13:00:43 2021 -0800

    xquartz: Fold away some unnecessary hops to X11Controller through X11Application
    
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
    (cherry picked from commit 4b4500c48f06e7ef41cd94f417e49b3f4f1412ae)

commit 7d22031a6bd949f9357904310422901515a5ace7
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Thu Feb 18 09:41:30 2021 -0800

    xquartz: Fold away array_with_strings_and_numbers and simplify with more modern Objective-C
    
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
    (cherry picked from commit 39c0e1c0ab6a0a89a71f26446973c779ca7fd927)

commit 937b63ff44edecc58ef020a0bfa453d98332482c
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Thu Feb 18 09:33:56 2021 -0800

    xqaurtz: Remove message_kit_thread() and use dispatch instead
    
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
    (cherry picked from commit 87f8fe1f74f10faf0ffc84f03539799ad4c2465e)

commit e531d3a4cbca1a689189fe512fed7d7aeb84de34
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Wed Feb 17 23:58:53 2021 -0800

    xquartz: Use objc_autoreleasePoolPush / objc_autoreleasePoolPop directly in QuartzBlockHandler
    
    It violates @autoreleasepool best practices, and this helps collapse quartzCocoa.m into quartz.c
    
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
    (cherry picked from commit 94e4e173486c2a94ddcfd2d0515e1ee6731f6656)

commit 08cf6c90fdc31a563843dceeae3caeb8840951da
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Wed Feb 17 22:04:55 2021 -0800

    xquartz: Minor code modernization -- @autoreleasepool adoption
    
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
    (cherry picked from commit fba421f700498fa382089df47942df36a2d75ce6)

commit 26e0c59a970229b343d00e6343436cbde2ce6354
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Wed Feb 17 20:55:06 2021 -0800

    xquartz: Remove some dead code for compatibility with older nibs
    
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
    (cherry picked from commit 318f8a4a8a47a0ce4bbbf4290469e933602c9b30)

commit 2853f38965f521cafb8991737db1c655960acc72
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Thu Feb 18 16:05:34 2021 -0800

    xquartz: Remove a workaround for AppKit versions older than Lion
    
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
    (cherry picked from commit 72a39dccf99191fbfbb4b399c446fd017d55f24e)

commit 1edc9b980b49e6f9c79f90b7045f9f94c5553247
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Thu Feb 18 22:26:08 2021 -0800

    xquartz: Apply spell check fixes from master for easier cherry-picking of changes in xquartz
    
    See also: 23e83724df4809fd7857cc609c33ce7e8d3021a4
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>

commit 67f25cc1870a587f0e687da9f1281031b6543533
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Wed Feb 17 15:45:45 2021 -0800

    xquartz: Fix applications menu table background color for dark mode
    
    Fixes: https://github.com/XQuartz/XQuartz/issues/32
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
    (cherry picked from commit 7e2875035800887f3f41f75cba4299088daf939a)

commit 4028c2ad14a71e6b0c8a892a154f1a50736f2dd5
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Wed Feb 17 15:16:26 2021 -0800

    xquartz: Apply Xcode 12.4 automatic updates to nibs
    
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
    (cherry picked from commit 85beee9885a8e65960fbbde2de9aa28598b4d6ae)

commit ff1c8e2f72a7dc978187a46e089577b09c009c27
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Wed Feb 17 13:38:31 2021 -0800

    xquartz: Update the about box copyright to 2021
    
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
    (cherry picked from commit 4e892aa6e132447e43d7bae7e3aca4f1fb172f93)

commit a16df6028458597c1ab722c7fe3464e6dd315b43
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Mon Feb 1 16:27:38 2021 -0800

    xquartz: Ensure we call into TIS on the main thread
    
    There is a place where this code was called on the main thread.
    
    We're using a rather nasty anti-pattern to just call a block inline rather
    than synchonously calling it on the main thread if we're already on the main
    thread.  This code could use a good overhaul, but I don't have time to rip
    it apart right now.  This will address the immediate issue.
    
    Fixes: https://github.com/XQuartz/XQuartz/issues/40
    Fixes: https://github.com/XQuartz/XQuartz/issues/48
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
    (cherry picked from commit c9a3b14c1472632afaff340f73a77a2b961f195a)

commit 2087b7782cde6e6a6c5b4786c2c1f136ee18bb51
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Wed Jan 27 15:03:46 2021 -0800

    xquartz: Ensure that NSRunAlertPanel() is run on the main thread
    
    Fixes: https://github.com/XQuartz/XQuartz/issues/30
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
    (cherry picked from commit 520e7a1310ddc25b30bcaa0ea3eeaa6c4d137c8c)

commit 2fe5bf4badb21479511479914def04bf29312e4d
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Wed Jan 27 13:46:02 2021 -0800

    xquartz: Remove support for older versions of libXplugin
    
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
    (cherry picked from commit 7d0bb7ed061458698ff27856976939b261e73b23)

commit bc1a2a0d830c76b03c5210b4059aea0f0470f095
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Wed Jan 27 13:43:01 2021 -0800

    xquartz: Remove unused include of AvailabilityMacros.h from various sources
    
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
    (cherry picked from commit 5e7c0762e6fdaefc9b8257c0f875432b1877c49e)

commit 393da8b4390f63e6b634a51f733f1b129626ee1a
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Wed Jan 27 13:40:48 2021 -0800

    xquartz: Remove support for building for i386
    
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
    (cherry picked from commit 59f22341a8b4cd468d6f37fb17dd7fde347e430b)

commit 43aaa10931b4d3a43c2c575cfd120bea442581ea
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Wed Jan 27 13:35:17 2021 -0800

    xquartz: Remove support for Mountain Lion and earlier versions of macOS
    
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
    (cherry picked from commit aea15a76593f98205e44f20632178dc384c02d57)

commit fb492686d70fc3166c005c273a587dc7dd4da651
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Wed Jan 27 13:33:22 2021 -0800

    xquartz: Remove support for Lion and earlier versions of macOS
    
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
    (cherry picked from commit c0b2d3e099a60f55b18ca9c30373000f12d40fe2)

commit 34784415ad7c369b93cee1deeea98e8610f133f2
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Wed Jan 27 13:29:52 2021 -0800

    xquartz: Remove support for SnowLeopard and earlier versions of macOS
    
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
    (cherry picked from commit cc9cf6f085be6e8264f925a11d67a12ad47a042b)

commit d3f81ecaf99c804728b206155875c52e41f0723b
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Wed Jan 27 13:09:50 2021 -0800

    xquartz: Remove check for libdispatch now that we don't support pre-SnowLeopard
    
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
    (cherry picked from commit f699aac2ea2cf6a3e2d3bdcb2d8179e103de1d4e)

commit 739c5bd32f5683c1e03c96700f5bb499517b3eaf
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Wed Jan 27 13:23:18 2021 -0800

    xquartz: Remove support for Leopard and earlier versions of macOS
    
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
    (cherry picked from commit 5ad49102722274f53b9b011082d9e0f202fcd9a4)

commit 2d7eb824996e51875a5bc8b76c159bb52249690c
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Wed Jan 27 13:18:35 2021 -0800

    xquartz: Remove support for Tiger and earlier versions of macOS
    
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
    (cherry picked from commit 6e6db055f8b517ae9d63351d4c00fd480cb6b54a)

commit 080f9eb76a13252f0fc132192ab99232df0e0d92
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Wed Jan 27 13:12:34 2021 -0800

    os: Remove support for Tiger and earlier versions of macOS
    
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
    (cherry picked from commit 20b86c4060c1d4fbc099675d5100fe17e4ac0147)

commit be9d2fd871139ec491806c0843af59cbac65fc84
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Wed Jan 27 13:25:54 2021 -0800

    xquartz: Remove support for Panther and earlier versions of macOS
    
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
    (cherry picked from commit 74aef85bd88a1fdb22d445ad14975232a7bebdd7)

commit d39eb58409a4452353c73d362d847f9262181e10
Author: Jim DeLaHunt <from.github@jdlh.com>
Date:   Mon Dec 11 00:08:52 2017 -0800

    Fix typo "XQaurtz" in Xquartz.man
    
    (cherry picked from commit 0e272ac458fbd530787273073473e566b0ac306e)

commit 1f2b73176f25567e28ac227faffd9311d6b65dff
Author: Christopher Chavez <chrischavez@gmx.us>
Date:   Sat Apr 25 05:09:51 2020 +0000

    XQuartz: recognize F16-F20 and Menu keys
    
    Signed-off-by: Christopher Chavez <chrischavez@gmx.us>
    (cherry picked from commit 462beb5338a44390e2fff03096942b035b509830)

commit ecc4ebf5355503268fc04923115b15b8d2e5d338
Author: Jon Turney <jon.turney@dronecode.org.uk>
Date:   Thu Apr 18 11:37:32 2019 +0100

    xquartz: Add stub ddxInputThread()
    
    Omitted from 4ad21c32
    
